---
title: List all roles
slug: api-documentation/list-all-roles
docTags: 
createdAt: 2026-08-27T17:06:32.549Z
---

{
  "id": "6E7SRVjqts6YYLa_jXFQj",
  "type": "api-oas-v2",
  "data": {
    "method": "GET",
    "url": "https://api.upstartcommerce.com/profile-permissions/roles",
    "servers": [
      {
        "url": "https://api.upstartcommerce.com/profile-permissions/roles",
        "description": "Production"
      }
    ],
    "name": "List all roles",
    "description": "<p>Returns all roles, optionally filtered by scope, tenant, site, and/or role type.</p>\n<p><strong>Required Permission:</strong> <code>profile-permissions.roles.list</code></p>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "scope",
          "type": "string",
          "description": "<p>Filter by role scope (GLOBAL, TENANT, or SITE)</p>",
          "enum": [
            "GLOBAL",
            "TENANT",
            "SITE"
          ]
        },
        {
          "kind": "optional",
          "name": "tenantId",
          "type": "string",
          "description": "<p>Filter by tenant ID (applicable when scope=TENANT or SITE)</p>"
        },
        {
          "kind": "optional",
          "name": "siteId",
          "type": "string",
          "description": "<p>Filter by site ID (applicable when scope=SITE)</p>"
        },
        {
          "kind": "optional",
          "name": "roleType",
          "type": "string",
          "description": "Filter by role type",
          "enum": [
            "Management",
            "Consumer"
          ]
        }
      ],
      "bodyDataParameters": [],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "bearerAuth",
          "name": "bearerAuth",
          "kind": "optional",
          "type": "http",
          "description": "<p>JWT token from authentication service.</p>\n<p>The token contains:</p>\n<ul>\n<li>sub: User ID</li>\n<li>tenant: Tenant ID (used for all operations)</li>\n<li>roles: Array of role IDs</li>\n<li>type: \"management\" or \"consumer\"</li>\n</ul>\n<p>Alternatively, tenant can be specified via X-Tenant-Id header.</p>",
          "scheme": "bearer"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "List of roles",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "A list of role definitions.",
            "customType": "RolesResponse",
            "schema": [
              {
                "name": "roles",
                "kind": "required",
                "type": "array",
                "description": "<p>A role definition - its scope (GLOBAL template, TENANT or SITE) and type (Management or Consumer) - without the permissions it grants.</p>",
                "modelRef": "#/components/schemas/Role",
                "customType": "Role[]",
                "schema": [
                  {
                    "name": "id",
                    "kind": "required",
                    "type": "string",
                    "description": "Role identifier"
                  },
                  {
                    "name": "name",
                    "kind": "required",
                    "type": "string",
                    "description": "<p>Role name (unique within scope/tenant/site)</p>",
                    "example": "operator"
                  },
                  {
                    "name": "scope",
                    "kind": "required",
                    "type": "string<GLOBAL | TENANT | SITE>",
                    "description": "<p>Role scope - GLOBAL for templates, TENANT for tenant-specific roles, SITE for site-specific roles</p>",
                    "enum": [
                      "GLOBAL",
                      "TENANT",
                      "SITE"
                    ]
                  },
                  {
                    "name": "tenantId",
                    "kind": "optional",
                    "type": "string",
                    "description": "<p>Tenant ID (required when scope is TENANT or SITE)</p>"
                  },
                  {
                    "name": "siteId",
                    "kind": "optional",
                    "type": "string",
                    "description": "<p>Site ID (required when scope is SITE)</p>"
                  },
                  {
                    "name": "roleDescription",
                    "kind": "optional",
                    "type": "string",
                    "description": "<p>Human-readable description</p>"
                  },
                  {
                    "name": "roleType",
                    "kind": "required",
                    "type": "string<Management | Consumer>",
                    "description": "<p>Role type - Management for admin users, Consumer for customers</p>",
                    "enum": [
                      "Management",
                      "Consumer"
                    ]
                  },
                  {
                    "name": "createdAt",
                    "kind": "required",
                    "type": "string<date-time>",
                    "description": "",
                    "format": "date-time"
                  },
                  {
                    "name": "updatedAt",
                    "kind": "required",
                    "type": "string<date-time>",
                    "description": "",
                    "format": "date-time"
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/RolesResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Missing or invalid authentication token",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>Error payload identifying the failure by error code and message, with optional detail.</p>",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "error",
                "kind": "required",
                "type": "string<bad_request | unauthorized | forbidden | not_found | conflict | internal_error>",
                "description": "Error code",
                "example": "not_found",
                "enum": [
                  "bad_request",
                  "unauthorized",
                  "forbidden",
                  "not_found",
                  "conflict",
                  "internal_error"
                ]
              },
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "<p>Human-readable error message</p>",
                "example": "Role not found"
              },
              {
                "name": "details",
                "kind": "optional",
                "type": "map",
                "description": "Additional error details",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "500",
        "description": "Internal server error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>Error payload identifying the failure by error code and message, with optional detail.</p>",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "error",
                "kind": "required",
                "type": "string<bad_request | unauthorized | forbidden | not_found | conflict | internal_error>",
                "description": "Error code",
                "example": "not_found",
                "enum": [
                  "bad_request",
                  "unauthorized",
                  "forbidden",
                  "not_found",
                  "conflict",
                  "internal_error"
                ]
              },
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "<p>Human-readable error message</p>",
                "example": "Role not found"
              },
              {
                "name": "details",
                "kind": "optional",
                "type": "map",
                "description": "Additional error details",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "nr0YHzI7ZotjkZ5NE-UUA",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request GET \\\n     --url https://api.upstartcommerce.com/profile-permissions/roles \\\n     --header 'accept: application/json'"
        },
        {
          "id": "ADVAnYPXLSbbGJZraIbto",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'GET',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.upstartcommerce.com/profile-permissions/roles\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "ieMhKAemP7o0YgBC2GhzN",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.upstartcommerce.com/profile-permissions/roles\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Get.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "Os35wSfNYH1RY9iHnFk5S",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.upstartcommerce.com/profile-permissions/roles\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"GET\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "nr0YHzI7ZotjkZ5NE-UUA"
    },
    "results": {
      "languages": [
        {
          "id": "XWKHcPpagdIpKnKd7TO8D",
          "language": "200",
          "code": "// List of roles\n{\n  \"roles\": [\n    {\n      \"id\": \"\",\n      \"name\": \"operator\",\n      \"scope\": \"\",\n      \"tenantId\": \"\",\n      \"siteId\": \"\",\n      \"roleDescription\": \"\",\n      \"roleType\": \"\",\n      \"createdAt\": \"\",\n      \"updatedAt\": \"\"\n    }\n  ]\n}"
        },
        {
          "id": "G5-JT1W2J5TZ_fjo5wl0Q",
          "language": "401",
          "code": "// Missing or invalid authentication token\n{\n  \"error\": \"not_found\",\n  \"message\": \"Role not found\",\n  \"details\": \"\"\n}"
        },
        {
          "id": "5MIMCFlrDQZel5T1h4PTq",
          "language": "500",
          "code": "// Internal server error\n{\n  \"error\": \"not_found\",\n  \"message\": \"Role not found\",\n  \"details\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "XWKHcPpagdIpKnKd7TO8D"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}